{
    layer = "top";
    position = "top";
    height = 32;

    modules-left = [
        "custom/launcher" 
        "hyprland/window"
    ];
    modules-center = [ "wlr/workspaces" ];
    modules-right = [
        "backlight"
        "pulseaudio"  # use pipewire, test needed.
        "cpu"
        "memory"
        "tray"
        "battery"
        "clock"
        "custom/power"
    ];

    pulseaudio = {
        tooltip = false;
        scroll-step = 5;
        format = "{icon} {volume}%";
        format-muted = "{icon} {volume}%";
        on-click ="pactl set-sink-mute @DEFAULT_SINK@ toggle";
        format-icons = {
            default = ["" "" ""];
        };
    };

    "wlr/workspaces" = {
        format = "{icon}";
        on-click = "activate";
        format-icons = {
            "1" = "";
            "2" = "";
            "3" = "";
            "4" = "";
            "5" = "";
            urgent = "";
            active = "";
            default = "";
        };
        sort-by-number = true;
    };

    network = {
        tooltip = false;
        format-wifi = "  {essid}";
        format-ethernet = "";
    };

    backlight = {
        tooltip = false;
        format = " {}%";
        interval = 1;
        on-scroll-up = "light -A 5";
        on-scroll-down = "light -U 5";
    };
    
    battery = {
        states = {
            good = 95;
            warning = 30;
            critical = 20;
        };
        format = "{icon}  {capacity}%";
        format-charging = " {capacity}%";
        format-plugged = " {capacity}%";
        format-alt = "{time} {icon}";
        format-icons = ["" "" "" "" ""];
    };

    tray = {
        icon-size = 16;
        spacing = 10;
    };

    clock = {
        format = "{ = %I =%M %p   %d/%m/%Y}";
    };

    cpu = {
        interval = 15;
        format = " {}%";
        max-length = 10;
    };

    memory = {
        interval = 30;
        format = " {}%";
        max-length = 10;
    };

    "custom/launcher" ={
        format = " ";
        on-click = "nwggrid -o 0.6";
    };

    "custom/power" ={
        format = " ";
        on-click = "nwgbar";
    };
}